Subject: [PATCH] add uboot logo function


diff --git a/arch/arm/imx-common/video.c b/arch/arm/imx-common/video.c
index bc34e12..20927a0 100644
--- a/arch/arm/imx-common/video.c
+++ b/arch/arm/imx-common/video.c
@@ -52,6 +52,9 @@ int board_video_skip(void)
 			       displays[i].mode.name,
 			       displays[i].mode.xres,
 			       displays[i].mode.yres);
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+			printf("xxx\n");
+#endif
 		} else
 			printf("LCD %s cannot be configured: %d\n",
 			       displays[i].mode.name, ret);
diff --git a/board/freescale/mx6advantech/mx6advantech.c b/board/freescale/mx6advantech/mx6advantech.c
index 5f1e205..9e47364 100755
--- a/board/freescale/mx6advantech/mx6advantech.c
+++ b/board/freescale/mx6advantech/mx6advantech.c
@@ -744,18 +744,42 @@ static void enable_lvds(struct display_info_t const *dev)
 	struct iomuxc *iomux = (struct iomuxc *)
 				IOMUXC_BASE_ADDR;
 	u32 reg = readl(&iomux->gpr[2]);
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	reg |= IOMUXC_GPR2_DATA_WIDTH_CH0_24BIT |
+		IOMUXC_GPR2_DATA_WIDTH_CH1_24BIT;
+#else
 	reg |= IOMUXC_GPR2_DATA_WIDTH_CH0_18BIT |
 	       IOMUXC_GPR2_DATA_WIDTH_CH1_18BIT;
+#endif
 	writel(reg, &iomux->gpr[2]);
 }
 
 struct display_info_t const displays[] = {{
 	.bus	= -1,
 	.addr	= 0,
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	.pixfmt	= IPU_PIX_FMT_RGB24,
+#else
 	.pixfmt	= IPU_PIX_FMT_RGB666,
+#endif
 	.detect	= NULL,
 	.enable	= enable_lvds,
 	.mode	= {
+#ifdef CONFIG_ADV_UBOOT_LOGO
+		.name           = "Hannstar-XGA",
+		.refresh        = 60,
+		.xres           = 800,
+		.yres           = 480,
+		.pixclock       = 15385,
+		.left_margin    = 220,
+		.right_margin   = 40,
+		.upper_margin   = 21,
+		.lower_margin   = 7,
+		.hsync_len      = 60,
+		.vsync_len      = 10,
+		.sync           = FB_SYNC_EXT,
+		.vmode          = FB_VMODE_NONINTERLACED
+#else
 		.name           = "Hannstar-XGA",
 		.refresh        = 60,
 		.xres           = 1024,
@@ -769,6 +793,7 @@ struct display_info_t const displays[] = {{
 		.vsync_len      = 10,
 		.sync           = FB_SYNC_EXT,
 		.vmode          = FB_VMODE_NONINTERLACED
+#endif
 } }, {
 	.bus	= -1,
 	.addr	= 0,
@@ -814,6 +839,10 @@ size_t display_count = ARRAY_SIZE(displays);
 
 static void setup_display(void)
 {
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+	printf("ADV UBOOT LOGO setup display !!!\n");
+#endif
+
 	struct mxc_ccm_reg *mxc_ccm = (struct mxc_ccm_reg *)CCM_BASE_ADDR;
 	struct iomuxc *iomux = (struct iomuxc *)IOMUXC_BASE_ADDR;
 	int reg;
@@ -825,11 +854,17 @@ static void setup_display(void)
 	imx_setup_hdmi();
 
 	/* Turn on LDB0, LDB1, IPU,IPU DI0 clocks */
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* mxc_ccm->CCGR3 address: 0x20c4074 */
+#endif
 	reg = readl(&mxc_ccm->CCGR3);
 	reg |=  MXC_CCM_CCGR3_LDB_DI0_MASK | MXC_CCM_CCGR3_LDB_DI1_MASK;
 	writel(reg, &mxc_ccm->CCGR3);
 
 	/* set LDB0, LDB1 clk select to 011/011 */
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* mxc_ccm->cs2cdr address: 0x20c402c */
+#endif
 	reg = readl(&mxc_ccm->cs2cdr);
 	reg &= ~(MXC_CCM_CS2CDR_LDB_DI0_CLK_SEL_MASK
 		 | MXC_CCM_CS2CDR_LDB_DI1_CLK_SEL_MASK);
@@ -837,34 +872,65 @@ static void setup_display(void)
 	      | (3 << MXC_CCM_CS2CDR_LDB_DI1_CLK_SEL_OFFSET);
 	writel(reg, &mxc_ccm->cs2cdr);
 
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* mxc_ccm->cscmr2 address: 0x20c4020 */
+#endif
 	reg = readl(&mxc_ccm->cscmr2);
 	reg |= MXC_CCM_CSCMR2_LDB_DI0_IPU_DIV | MXC_CCM_CSCMR2_LDB_DI1_IPU_DIV;
 	writel(reg, &mxc_ccm->cscmr2);
 
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* mxc_ccm->chsccdr address: 0x20c4034 */
+#endif
 	reg = readl(&mxc_ccm->chsccdr);
 	reg |= (CHSCCDR_CLK_SEL_LDB_DI0
 		<< MXC_CCM_CHSCCDR_IPU1_DI0_CLK_SEL_OFFSET);
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	reg &= ~(MXC_CCM_CHSCCDR_IPU1_DI1_CLK_SEL_MASK);
+#endif
 	reg |= (CHSCCDR_CLK_SEL_LDB_DI0
 		<< MXC_CCM_CHSCCDR_IPU1_DI1_CLK_SEL_OFFSET);
 	writel(reg, &mxc_ccm->chsccdr);
 
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* iomux->gpr[2] address: 0x20e0008 */
+#endif
 	reg = IOMUXC_GPR2_BGREF_RRMODE_EXTERNAL_RES
 	     | IOMUXC_GPR2_DI1_VS_POLARITY_ACTIVE_LOW
 	     | IOMUXC_GPR2_DI0_VS_POLARITY_ACTIVE_LOW
 	     | IOMUXC_GPR2_BIT_MAPPING_CH1_SPWG
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	     | IOMUXC_GPR2_DATA_WIDTH_CH1_24BIT
+#else
 	     | IOMUXC_GPR2_DATA_WIDTH_CH1_18BIT
+#endif
 	     | IOMUXC_GPR2_BIT_MAPPING_CH0_SPWG
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	     | IOMUXC_GPR2_DATA_WIDTH_CH0_24BIT
+	     | IOMUXC_GPR2_LVDS_CH0_MODE_ENABLED_DI0
+             | IOMUXC_GPR2_LVDS_CH1_MODE_DISABLED;
+#else
 	     | IOMUXC_GPR2_DATA_WIDTH_CH0_18BIT
 	     | IOMUXC_GPR2_LVDS_CH0_MODE_DISABLED
 	     | IOMUXC_GPR2_LVDS_CH1_MODE_ENABLED_DI0;
+#endif
 	writel(reg, &iomux->gpr[2]);
 
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	/* iomux->gpr[3] address: 0x20e000c */
+#endif
 	reg = readl(&iomux->gpr[3]);
+
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	reg &= ~(IOMUXC_GPR3_LVDS1_MUX_CTL_MASK);
+	writel(reg, &iomux->gpr[3]);
+#else
 	reg = (reg & ~(IOMUXC_GPR3_LVDS1_MUX_CTL_MASK
 			| IOMUXC_GPR3_HDMI_MUX_CTL_MASK))
 	    | (IOMUXC_GPR3_MUX_SRC_IPU1_DI0
 	       << IOMUXC_GPR3_LVDS1_MUX_CTL_OFFSET);
 	writel(reg, &iomux->gpr[3]);
+#endif
 }
 #endif /* CONFIG_VIDEO_IPUV3 */
 
@@ -985,9 +1051,15 @@ int board_early_init_f(void)
 #if defined (CONFIG_ADVANTECH) && defined(CONFIG_SUPPORT_LVDS)
 void setup_lvds_init(void)
 {
+#ifdef CONFIG_ADV_UBOOT_LOGO
+	imx_iomux_v3_setup_pad(IOMUX_LCD_BKLT_PWM | MUX_PAD_CTRL(NO_PAD_CTRL)); /* LCD_BKLT_PWM */
+	imx_iomux_v3_setup_pad(IOMUX_LCD_BKLT_EN | MUX_PAD_CTRL(NO_PAD_CTRL)); /* LCD_BKLT_EN */
+	imx_iomux_v3_setup_pad(IOMUX_LCD_VDD_EN | MUX_PAD_CTRL(NO_PAD_CTRL)); /* LCD_VDD_EN */
+#else
 	imx_iomux_v3_setup_pad(IOMUX_LCD_BKLT_PWM); /* LCD_BKLT_PWM */
 	imx_iomux_v3_setup_pad(IOMUX_LCD_BKLT_EN); /* LCD_BKLT_EN */
 	imx_iomux_v3_setup_pad(IOMUX_LCD_VDD_EN); /* LCD_VDD_EN */
+#endif
 
 	/* LCD_BKLT_PWM - disable pwm */
 	gpio_direction_output(LCD_BKLT_PWM, 0);
@@ -1005,15 +1077,44 @@ void setup_lvds_init(void)
 #else
 	gpio_direction_output(LCD_VDD_EN, 0);
 #endif
+
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+	printf("ADV UBOOT LOGO setup_lvds_init \n");
+#endif
+}
+
+#ifdef CONFIG_ADV_UBOOT_LOGO
+void setup_lvds_poweron(void)
+{
+	//LCD_BKLT_EN
+	gpio_direction_output(LCD_BKLT_EN, 1);
+	gpio_set_value(LCD_BKLT_EN,1);
+
+	//LCD_VDD_EN
+	gpio_direction_output(LCD_VDD_EN, 1);
+	gpio_set_value(LCD_VDD_EN,1);
+
+	gpio_direction_output(LCD_BKLT_PWM, 1);
+	gpio_set_value(LCD_BKLT_PWM,1);
 }
+#endif // #ifdef CONFIG_ADV_UBOOT_LOGO
 
 #endif
 int board_init(void)
 {
+#ifdef CONFIG_ADV_UBOOT_LOGO
+       printf("ADV UBOOT LOGO board_init() \n");
+#endif
+
 	/* address of boot parameters */
 	gd->bd->bi_boot_params = PHYS_SDRAM + 0x100;
 #if defined (CONFIG_ADVANTECH) && defined(CONFIG_SUPPORT_LVDS)
        setup_lvds_init();
+
+#ifdef CONFIG_ADV_UBOOT_LOGO
+       setup_lvds_poweron();
+#endif
+
 #endif
 #ifdef CONFIG_MXC_SPI
 	setup_spi();
diff --git a/drivers/video/cfb_console.c b/drivers/video/cfb_console.c
index 8f552cd..9712034 100644
--- a/drivers/video/cfb_console.c
+++ b/drivers/video/cfb_console.c
@@ -311,6 +311,19 @@ extern void video_get_info_str(int line_number,	char *info);
 
 DECLARE_GLOBAL_DATA_PTR;
 
+#ifdef CONFIG_ADV_UBOOT_LOGO_EMMC
+#include <mmc.h>
+#include <common.h>
+#include <asm/ioNew.h>
+
+#define UBOOT_LOGO_BMP_ADDR 0x00100000
+#define DISPLAY_WIDTH 800
+#define DISPLAY_HEIGHT 480
+#define DISPLAY_BPP 16
+//#define CONFIG_FB_BASE (CONFIG_SYS_TEXT_BASE + 0x300000)
+#define CONFIG_FB_BASE VIDEO_FB_ADRS
+#endif
+
 /* Locals */
 static GraphicDevice *pGD;	/* Pointer to Graphic array */
 
@@ -1953,7 +1966,9 @@ static void *video_logo(void)
 	}
 #endif /* CONFIG_SPLASH_SCREEN */
 
+#ifndef CONFIG_ADV_UBOOT_LOGO_EMMC
 	logo_plot(video_fb_address, video_logo_xpos, video_logo_ypos);
+#endif
 
 #ifdef CONFIG_SPLASH_SCREEN_ALIGN
 	/*
@@ -2090,6 +2105,14 @@ void video_clear(void)
 #endif
 }
 
+#ifdef CONFIG_ADV_UBOOT_LOGO_EMMC
+int get_mmc_env_devno(void)
+{
+	uint soc_sbmr = readl(SRC_BASE_ADDR + 0x4);
+	return (soc_sbmr & 0x00001800) >> 11;
+}
+#endif
+
 static int video_init(void)
 {
 	unsigned char color8;
@@ -2108,6 +2131,9 @@ static int video_init(void)
 	/* Init drawing pats */
 	switch (VIDEO_DATA_FORMAT) {
 	case GDF__8BIT_INDEX:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF__8BIT_INDEX ...\n");
+#endif
 		video_set_lut(0x01, CONSOLE_FG_COL, CONSOLE_FG_COL,
 			      CONSOLE_FG_COL);
 		video_set_lut(0x00, CONSOLE_BG_COL, CONSOLE_BG_COL,
@@ -2116,6 +2142,9 @@ static int video_init(void)
 		bgx = 0x00000000;
 		break;
 	case GDF__8BIT_332RGB:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF__8BIT_332RGB ...\n");
+#endif
 		color8 = ((CONSOLE_FG_COL & 0xe0) |
 			  ((CONSOLE_FG_COL >> 3) & 0x1c) |
 			  CONSOLE_FG_COL >> 6);
@@ -2128,6 +2157,9 @@ static int video_init(void)
 			color8;
 		break;
 	case GDF_15BIT_555RGB:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF_15BIT_555RGB ...\n");
+#endif
 		fgx = (((CONSOLE_FG_COL >> 3) << 26) |
 		       ((CONSOLE_FG_COL >> 3) << 21) |
 		       ((CONSOLE_FG_COL >> 3) << 16) |
@@ -2142,6 +2174,9 @@ static int video_init(void)
 			(CONSOLE_BG_COL >> 3));
 		break;
 	case GDF_16BIT_565RGB:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF_16BIT_565RGB ...\n");
+#endif
 		fgx = (((CONSOLE_FG_COL >> 3) << 27) |
 		       ((CONSOLE_FG_COL >> 2) << 21) |
 		       ((CONSOLE_FG_COL >> 3) << 16) |
@@ -2156,6 +2191,9 @@ static int video_init(void)
 			(CONSOLE_BG_COL >> 3));
 		break;
 	case GDF_32BIT_X888RGB:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF_32BIT_X888RGB ...\n");
+#endif
 		fgx =	(CONSOLE_FG_COL << 16) |
 			(CONSOLE_FG_COL <<  8) |
 			 CONSOLE_FG_COL;
@@ -2164,6 +2202,9 @@ static int video_init(void)
 			 CONSOLE_BG_COL;
 		break;
 	case GDF_24BIT_888RGB:
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		printf("Video: GDF_24BIT_888RGB ...\n");
+#endif
 		fgx =	(CONSOLE_FG_COL << 24) |
 			(CONSOLE_FG_COL << 16) |
 			(CONSOLE_FG_COL <<  8) |
@@ -2182,6 +2223,87 @@ static int video_init(void)
 	/* Plot the logo and get start point of console */
 	debug("Video: Drawing the logo ...\n");
 	video_console_address = video_logo();
+
+#ifdef CONFIG_ADV_UBOOT_LOGO_EMMC
+   unsigned int size = DISPLAY_WIDTH * DISPLAY_HEIGHT * (DISPLAY_BPP / 8);
+   unsigned char * pData;
+   unsigned int start, count;
+   int i, bmpReady = 0;
+   int mmc_dev = get_mmc_env_devno();
+
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+   printf("mmc_dev:%d\n", mmc_dev);
+#endif
+
+   struct mmc *mmc = find_mmc_device(mmc_dev);
+
+   pData = (unsigned char *)CONFIG_FB_BASE;
+
+   if (mmc){
+	   if (mmc_init(mmc) == 0) {
+		   start = ALIGN(UBOOT_LOGO_BMP_ADDR, mmc->read_bl_len) / mmc->read_bl_len;
+		   count = ALIGN(size, mmc->read_bl_len) / mmc->read_bl_len;
+		   mmc->block_dev.block_read(&mmc->block_dev, start, count, pData);
+
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		   printf("start %x \n" ,start);
+		   printf("mmc->read_bl_len %x \n" ,mmc->read_bl_len);
+		   printf("count %x \n" ,count);
+#endif
+		   bmpReady = 1;
+//		   for(i=0;i<count;i++)
+//			   printf("0x%x ",pData[i]);
+//		   printf("\n");
+#ifdef CONFIG_ADV_UBOOT_LOGO_DEBUG
+		   printf("Display emmc logo !!! \n");
+		   printf("DISPLAY_BPP %d !!! \n",DISPLAY_BPP);
+#endif
+	   }
+   }
+		
+	//printf("display r g b !!! \n");
+	//bmpReady = 0;
+	//r g b bpp is 16,is ok
+    if (bmpReady == 0) {
+	   // Fill RGB frame buffer
+	   // Red
+	   for (i = 0; i < (DISPLAY_WIDTH * DISPLAY_HEIGHT * (DISPLAY_BPP / 8) / 3); i += (DISPLAY_BPP / 8)) {
+#if (DISPLAY_BPP == 16)
+		   pData[i + 0] = 0x00;
+		   pData[i + 1] = 0xF8;
+#else
+		   pData[i + 0] = 0x00;
+		   pData[i + 1] = 0x00;
+		   pData[i + 2] = 0xFF;
+#endif
+        }
+
+	   // Green
+	   for (; i < (DISPLAY_WIDTH * DISPLAY_HEIGHT * (DISPLAY_BPP / 8) / 3) * 2; i += (DISPLAY_BPP / 8)) {
+#if (DISPLAY_BPP == 16)
+		   pData[i + 0] = 0xE0;
+		   pData[i + 1] = 0x07;
+#else
+		   pData[i + 0] = 0x00;
+		   pData[i + 1] = 0xFF;
+		   pData[i + 2] = 0x00;
+#endif
+        }
+
+	   // Blue
+	   for (; i < DISPLAY_WIDTH * DISPLAY_HEIGHT * (DISPLAY_BPP / 8); i += (DISPLAY_BPP / 8)) {
+#if (DISPLAY_BPP == 16)
+		   pData[i + 0] = 0x1F;
+		   pData[i + 1] = 0x00;
+#else
+		   pData[i + 0] = 0xFF;
+		   pData[i + 1] = 0x00;
+		   pData[i + 2] = 0x00;
+#endif
+        }
+    }
+#endif //#ifdef CONFIG_ADV_UBOOT_LOGO_EMMC
+
 #else
 	video_console_address = video_fb_address;
 #endif
diff --git a/include/configs/mx6advantech_common.h b/include/configs/mx6advantech_common.h
index 56f3595..1dd422d 100644
--- a/include/configs/mx6advantech_common.h
+++ b/include/configs/mx6advantech_common.h
@@ -51,6 +51,10 @@
 #define CONFIG_PHYLIB
 #define CONFIG_PHY_ATHEROS
 
+#define CONFIG_ADV_UBOOT_LOGO
+#define CONFIG_ADV_UBOOT_LOGO_EMMC
+/* #define CONFIG_ADV_UBOOT_LOGO_DEBUG */
+
 /* Command definition */
 #define CONFIG_CMD_BMODE
 
@@ -409,6 +413,33 @@
 #define CONFIG_SYS_I2C_MXC_I2C3		/* enable I2C bus 3 */
 #define CONFIG_SYS_I2C_SPEED		  100000
 
+#ifdef CONFIG_ADV_UBOOT_LOGO /* alex */
+#ifdef CONFIG_ADVANTECH
+
+/* Framebuffer */
+#define CONFIG_VIDEO
+#define CONFIG_VIDEO_IPUV3
+#define CONFIG_CFB_CONSOLE
+#define CONFIG_VGA_AS_SINGLE_DEVICE
+#define CONFIG_SYS_CONSOLE_IS_IN_ENV
+#define CONFIG_SYS_CONSOLE_OVERWRITE_ROUTINE
+#define CONFIG_VIDEO_BMP_RLE8
+#define CONFIG_SPLASH_SCREEN
+#define CONFIG_SPLASH_SCREEN_ALIGN
+#define CONFIG_BMP_16BPP
+#define CONFIG_VIDEO_LOGO
+#define CONFIG_VIDEO_BMP_LOGO
+#ifdef CONFIG_MX6DL
+#define CONFIG_IPUV3_CLK 198000000
+#else
+#define CONFIG_IPUV3_CLK 264000000
+#endif
+#define CONFIG_IMX_HDMI
+#define CONFIG_IMX_VIDEO_SKIP
+#endif /* #ifdef CONFIG_ADVANTECH */
+
+#endif /* #ifdef CONFIG_ADV_UBOOT_LOGO - alex */
+
 #if defined(CONFIG_ANDROID_SUPPORT)
 #include "mx6sabreandroid_common.h"
 #else
-- 
2.7.4

